IF EXISTS (SELECT 1 FROM sys.objects WHERE object_id = OBJECT_ID('[dbo].[sp_dropdiagram]') AND type = 'P')
DROP PROCEDURE [dbo].[sp_dropdiagram]
GO

CREATE PROCEDURE dbo.sp_dropdiagram
(
@diagramname sysname,
@owner_idint= null
)
WITH EXECUTE AS 'dbo'
AS
BEGIN
set nocount on
declare @theId int
declare @IsDbo int

declare @UIDFound int
declare @DiagIdint

if(@diagramname is null)
begin
RAISERROR ('Invalid value', 16, 1);
return -1
end

EXECUTE AS CALLER;
select @theId = DATABASE_PRINCIPAL_ID();
select @IsDbo = IS_MEMBER(N'db_owner'); 
if(@owner_id is null)
select @owner_id = @theId;
REVERT; 

select @DiagId = diagram_id, @UIDFound = principal_id from dbo.sysdiagrams where principal_id = @owner_id and name = @diagramname 
if(@DiagId IS NULL or (@IsDbo = 0 and @UIDFound <> @theId))
begin
RAISERROR ('Diagram does not exist or you do not have permission.', 16, 1)
return -3
end

delete from dbo.sysdiagrams where diagram_id = @DiagId;

return 0;
END